# frozen_string_literal: true

module ActionPush
  module Concerns
    module RegisterDefault
      def defaults
        @defaults ||= {}
      end

      def register_default(provider, placeholder)
        defaults[provider] = placeholder.dup.freeze
      end

      def default(provider)
        placeholder = defaults[provider].dup

        yield(placeholder) if block_given?

        register_default(provider, placeholder)
      end
    end
  end
end
