# frozen_string_literal: true

module ActionPush
  module Delivery
    class Memory
      class << self
        include Enumerable
        extend Forwardable

        def_delegators :pushes, :each, :clear, :last, :first, :size, :[]

        def call(push)
          pushes.push(push)
        end

        def pushes
          @pushes ||= []
        end
      end
    end
  end
end
